package connector;

public class DatabaseConnectionDialog extends javax.swing.JDialog {
    public static final int RET_CANCEL = 0;
    public static final int RET_OK = 1;
    
    public DatabaseConnectionDialog(
            java.awt.Frame parent, 
            boolean modal) {

        super(
                parent, 
                modal );
        initComponents();
        mConnector = null;
        RDBMSMounter lMounter = RDBMSMounter.getInstance();
        
        int lDriversNumber = lMounter.getNumber();
        for( int iDriver = 0; iDriver < lDriversNumber; iDriver++ ) {
            msTypeComboBox.addItem( lMounter.getName( iDriver ) );
        }
        
        ConnectionParametersXMLReader lReader = ConnectionParametersXMLReader.getInstance();
        lReader.setParametersFilePath( "database.xml" );
        ConnectionParameters lParameters = lReader.readParameters();
        if( lParameters != null ) {
            msHostField.setText( lParameters.getHost() );
            msPortField.setText( lParameters.getPort().toString() );
            msDatabaseField.setText( lParameters.getDatabase() );
            msLoginField.setText( lParameters.getLogin() );
        }
    }
    
    public int getReturnStatus() {
        
        return mReturnStatus;
    }
    

    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        msEstablishLabel = new javax.swing.JLabel();
        msEstablishField = new javax.swing.JTextField();
        msParametersPanel = new javax.swing.JPanel();
        msHostLabel = new javax.swing.JLabel();
        msHostField = new javax.swing.JTextField();
        msPortLabel = new javax.swing.JLabel();
        msPortField = new javax.swing.JTextField();
        msDatabaseLabel = new javax.swing.JLabel();
        msDatabaseField = new javax.swing.JTextField();
        msLoginLabel = new javax.swing.JLabel();
        msLoginField = new javax.swing.JTextField();
        msPasswordLabel = new javax.swing.JLabel();
        msPasswordField = new javax.swing.JPasswordField();
        msTypeLabel = new javax.swing.JLabel();
        msTypeComboBox = new javax.swing.JComboBox();
        msEstablishButton = new javax.swing.JButton();

        setTitle("\u0421\u043e\u0435\u0434\u0438\u043d\u0435\u043d\u0438\u0435 \u0441 \u044d\u043b\u0435\u043a\u0442\u0440\u043e\u043d\u043d\u043e\u0439 \u0431\u0438\u0431\u043b\u0438\u043e\u0442\u0435\u043a\u043e\u0439");
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        okButton.setText("\u041f\u0440\u0438\u043d\u044f\u0442\u044c");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText("\u041e\u0442\u043c\u0435\u043d\u0438\u0442\u044c");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        msEstablishLabel.setText("\u0421\u043e\u0435\u0434\u0438\u043d\u0435\u043d\u0438\u0435");

        msEstablishField.setEditable(false);
        msEstablishField.setFont(new java.awt.Font("Tahoma", 1, 11));
        msEstablishField.setText("\u043e\u0442\u0441\u0443\u0442\u0441\u0442\u0432\u0443\u0435\u0442");

        msParametersPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED), "", javax.swing.border.TitledBorder.LEFT, javax.swing.border.TitledBorder.TOP));
        msHostLabel.setText("\u0425\u043e\u0441\u0442");

        msPortLabel.setText("\u041f\u043e\u0440\u0442");

        msDatabaseLabel.setText("\u0411\u0430\u0437\u0430 \u0434\u0430\u043d\u043d\u044b\u0445");

        msLoginLabel.setText("\u041f\u043e\u043b\u044c\u0437\u043e\u0432\u0430\u0442\u0435\u043b\u044c");

        msPasswordLabel.setText("\u041f\u0430\u0440\u043e\u043b\u044c");

        msTypeLabel.setText("\u0422\u0438\u043f \u0421\u0423\u0411\u0414");

        org.jdesktop.layout.GroupLayout msParametersPanelLayout = new org.jdesktop.layout.GroupLayout(msParametersPanel);
        msParametersPanel.setLayout(msParametersPanelLayout);
        msParametersPanelLayout.setHorizontalGroup(
            msParametersPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(msParametersPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(msParametersPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(msParametersPanelLayout.createSequentialGroup()
                        .add(msHostLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 84, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(msHostField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 263, Short.MAX_VALUE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, msParametersPanelLayout.createSequentialGroup()
                        .add(msPortLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 84, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(msPortField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 263, Short.MAX_VALUE))
                    .add(msParametersPanelLayout.createSequentialGroup()
                        .add(msDatabaseLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 84, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(msDatabaseField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 263, Short.MAX_VALUE))
                    .add(msParametersPanelLayout.createSequentialGroup()
                        .add(msParametersPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, msTypeLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, msPasswordLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 84, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, msLoginLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 84, Short.MAX_VALUE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(msParametersPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, msPasswordField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 263, Short.MAX_VALUE)
                            .add(msLoginField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 263, Short.MAX_VALUE)
                            .add(msTypeComboBox, 0, 263, Short.MAX_VALUE))))
                .addContainerGap())
        );
        msParametersPanelLayout.setVerticalGroup(
            msParametersPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(msParametersPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(msParametersPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(msHostField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(msHostLabel))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msParametersPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(msPortField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(msPortLabel))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msParametersPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(msDatabaseField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(msDatabaseLabel))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msParametersPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(msLoginField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(msLoginLabel))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msParametersPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(msPasswordLabel)
                    .add(msPasswordField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msParametersPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(msTypeLabel)
                    .add(msTypeComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(18, Short.MAX_VALUE))
        );

        msEstablishButton.setText("\u041f\u043e\u0434\u0433\u043e\u0442\u043e\u0432\u0438\u0442\u044c \u0441\u043e\u0435\u0434\u0438\u043d\u0435\u043d\u0438\u0435");
        msEstablishButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                msEstablishButtonActionPerformed(evt);
            }
        });

        msEstablishButton.getAccessibleContext().setAccessibleName("200");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, msParametersPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(msEstablishLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 100, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(msEstablishField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 279, Short.MAX_VALUE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(okButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 150, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 83, Short.MAX_VALUE)
                        .add(cancelButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 150, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, msEstablishButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 200, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(msParametersPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(15, 15, 15)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(msEstablishLabel)
                    .add(msEstablishField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msEstablishButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 36, Short.MAX_VALUE)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(cancelButton)
                    .add(okButton))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void msEstablishButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_msEstablishButtonActionPerformed
        
        mConnector = null;
        RDBMSMounter lMounter = RDBMSMounter.getInstance();
        
        int lRDBMSNumber = msTypeComboBox.getSelectedIndex();
        if( ! lMounter.mountDriver( lRDBMSNumber ) ) {
            msEstablishField.setText( "  " );
        }
        
        ConnectionParameters lParameters = null;
        try {
            lParameters = new ConnectionParameters(
                    msHostField.getText(),
                    new Integer( msPortField.getText() ),
                    msDatabaseField.getText(),
                    msLoginField.getText(),
                    new String( msPasswordField.getPassword() ) );
        } catch( IllegalArgumentException eFailed ) {
            msEstablishField.setText( "  " );
            return;
        }
        
        RDBMSConnector lConnector = lMounter.getConnector( lRDBMSNumber );
        lConnector.setParameters( lParameters );
        if( lConnector.mountConnection() != null ) {
            mConnector = lConnector;
            msEstablishField.setText( " " );
        } else {
            msEstablishField.setText( " " );
        }
    }//GEN-LAST:event_msEstablishButtonActionPerformed
    
    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        doClose(RET_OK);
    }//GEN-LAST:event_okButtonActionPerformed
    
    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        mConnector = null;
        doClose(RET_CANCEL);
    }//GEN-LAST:event_cancelButtonActionPerformed
    
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        mConnector = null;
        doClose(RET_CANCEL);
    }//GEN-LAST:event_closeDialog
    
    private void doClose(int retStatus) {
        mReturnStatus = retStatus;
        setVisible(false);
        dispose();
    }
    
    public static void main(
            String args[] ) {
        java.awt.EventQueue.invokeLater( new Runnable() {
            public void run() {
                new DatabaseConnectionDialog( 
                        new javax.swing.JFrame(), 
                        true ).setVisible( true );
            }
        } );
     }
    
    public RDBMSConnector getConnector() {
        
        return mConnector;
    }
    
     private int mReturnStatus = RET_CANCEL;
     private RDBMSConnector mConnector;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JTextField msDatabaseField;
    private javax.swing.JLabel msDatabaseLabel;
    private javax.swing.JButton msEstablishButton;
    private javax.swing.JTextField msEstablishField;
    private javax.swing.JLabel msEstablishLabel;
    private javax.swing.JTextField msHostField;
    private javax.swing.JLabel msHostLabel;
    private javax.swing.JTextField msLoginField;
    private javax.swing.JLabel msLoginLabel;
    private javax.swing.JPanel msParametersPanel;
    private javax.swing.JPasswordField msPasswordField;
    private javax.swing.JLabel msPasswordLabel;
    private javax.swing.JTextField msPortField;
    private javax.swing.JLabel msPortLabel;
    private javax.swing.JComboBox msTypeComboBox;
    private javax.swing.JLabel msTypeLabel;
    private javax.swing.JButton okButton;
    // End of variables declaration//GEN-END:variables
}
