package connector;

import java.util.Vector;

public class RDBMSMounter {
    
    private RDBMSMounter() {
        
        mName = new Vector< String >();
        mDriverURI = new Vector< String >();
        mConnector = new Vector< RDBMSConnector >();
    }
    
    public int getNumber() {
        
        return mName.size();
    }
    
    public String getName(
            int pNumber ) {
        
        if( ( pNumber >= 0  ) && ( pNumber < mName.size() ) ) {
            return new String( mName.get( pNumber ) );
        } else {
            return null;
        }
    }
    
    public String getDriverURI(
            int pNumber ) {
        
        if( ( pNumber >= 0  ) && ( pNumber < mDriverURI.size() ) ) {
            return new String( mDriverURI.get( pNumber ) );
        } else {
            return null;
        }
    }
    
    public RDBMSConnector getConnector( 
            int pNumber ) {
        
        if( ( pNumber >= 0 ) && ( pNumber < mConnector.size() ) ) {
            return mConnector.get( pNumber );
        } else {
            return null;
        }
    }
    
    public int add(
            String pName,
            String pDriverURI,
            RDBMSConnector pConnector) {
        
        int lNumber = -1;
        final int cErrorneous = -1;
        if( pName == null )  {
            return cErrorneous;
        }
        if( pName.trim().length() == 0 ) {
            return cErrorneous;
        }
        if( pDriverURI == null ) {
            return cErrorneous;
        }
        if ( pDriverURI.trim().length() == 0 ) {
            return cErrorneous;
        }
        if( pConnector == null ) {
            return cErrorneous;
        }
        mName.add( new String( pName.trim() ) );
        mDriverURI.add( new String( pDriverURI.trim() ) );
        mConnector.add( pConnector );
        return ( mName.size() - 1 );
    }
    
    public boolean mountDriver(
            int pNumber ) {
        
        boolean lDriverMounted = false;
        if( ( pNumber >= 0  ) && ( pNumber < mName.size() ) ) {
            try {
                Class.forName( mDriverURI.get( pNumber ) ).newInstance();
                lDriverMounted = true;
            } catch ( Exception eLoadingFailed ) {
                lDriverMounted = false;
            }
        }
        return lDriverMounted;
    }
    
    public static RDBMSMounter getInstance() {
        
        return mInstance;
    }
    
    private static RDBMSMounter mInstance = new RDBMSMounter();
    
    private Vector< String > mName;
    private Vector< String > mDriverURI;
    private Vector< RDBMSConnector > mConnector;    
}