package publications;

public class Author {
    
    public Author(
            String pName,
            String pSurname )
            throws IllegalArgumentException {
        
        if( pName == null ) {
            System.out.println( "Illegal Name argument: is null." );
            throw new IllegalArgumentException( "Illegal Name argument: is null." );
        }
        if( pName.trim().length() == 0 ) {
            System.out.println( "Illegal Name argument: is empty." );
            throw new IllegalArgumentException( "Illegal Name argument: is empty." );
        }
        if( pSurname == null ) {
            System.out.println( "Illegal Surname argument: is null." );
            throw new IllegalArgumentException( "Illegal Surname argument: is null." );
        }
        if( pSurname.trim().length() == 0 ) {
            System.out.println( "Illegal Surname argument: is empty." );
            throw new IllegalArgumentException( "Illegal Surname argument: is empty." );
        }
        mName = new String( pName );
        mSurname = new String( pSurname );
    }
    
    public Author( 
            Author pPrototype )
            throws IllegalArgumentException {
        
        if( pPrototype == null ) {
            System.out.println( "Illegal Prototype argument: is null." );
            throw new IllegalArgumentException( "Illegal Prototype argument: is null." );
        }
        mName = new String( pPrototype.getName() );
        mSurname = new String( pPrototype.getSurname() );
    }
    
    public boolean setName(
            String pName ) {
        
        if( pName == null )  {
            return false;
        }
        if( pName.trim().length() == 0 ) {
            return false;
        }
        mName = new String( pName );
        return true;
    }
    
    public String getName() {
        
        return new String( mName );
    }
    
    public boolean setSurname(
            String pSurname ) {
        
        if( pSurname == null )  {
            return false;
        }
        if( pSurname.trim().length() == 0 ) {
            return false;
        }
        mSurname = new String( pSurname );
        return true;
    }
    
    public String getSurname() {
        
        return new String( mSurname );
    }
    
    public Author clone() {
        
        Author lClone = null;
        try {
            lClone =  new Author( this );
        } catch ( IllegalArgumentException eFakeException ) {
            
        }
        return lClone;
    }
    
    public boolean equals( 
            Object pInstance ) {
        
        if( pInstance == null ) {
            return false;
        }
        if( pInstance instanceof Author ) {
            Author lInstance = ( Author )pInstance;
            if( mName.equals( lInstance.getName() ) &&
                    mSurname.equals( lInstance.getSurname() ) ) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }	
	
    private String mName;
    private String mSurname;
}