package publications;

public abstract class Bookmark {
    
    public Bookmark(
            String pTitle,
            BookmarkType pType )
            throws IllegalArgumentException {
        
        if( pTitle == null ) {
            System.out.println( "Illegal Title argument: is null." );
            throw new IllegalArgumentException( "Illegal Title argument: is null." );
        }
        if( pTitle.trim().length() == 0 ) {
            System.out.println( "Illegal Title argument: is empty." );
            throw new IllegalArgumentException( "Illegal Title argument: is empty." );
        }
        mTitle = new String( pTitle );
        mType = pType;
    }
    
    public Bookmark(
            Bookmark pPrototype )
            throws IllegalArgumentException {
        
        if( pPrototype == null ) {
            System.out.println( "Illegal Prototype argument: is null." );
            throw new IllegalArgumentException( "Illegal Prototype argument: is null." );
        }
        mTitle = new String( pPrototype.mTitle );
        mType = pPrototype.mType;
    }
    
    public boolean setTitle(
            String pTitle ) {
        
        if( pTitle == null ) {
            return false;
        }
        if( pTitle.trim().length() == 0 ) {
            return false;
        }
        mTitle = new String( pTitle );
        return true;
    }
    
    public String getTitle() {
        
        return new String( mTitle );
    }
    
    public void setType(
            BookmarkType pType ) {
        
        mType = pType;
    }
    
    public BookmarkType getType() {
        
        return mType;
    }
    
    public boolean equals(
            Object pInstance ) {
        
        if( pInstance == null ) {
            return false;
        }
        if( pInstance instanceof Bookmark ) {
            Bookmark lBookmarkInstance = ( Bookmark )pInstance;
            if( mTitle.equals( lBookmarkInstance.getTitle() ) &&
                ( mType == lBookmarkInstance.getType() ) ) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
    
    public abstract Bookmark clone();
    
    private String mTitle;
    private BookmarkType mType;
}