package readers;

import publications.Bookmark;
import publications.BookmarkType;

public class DatabaseBookmark
    extends Bookmark {
    
    public DatabaseBookmark(
            String pTitle,
            BookmarkType pType,
            Integer pKey )
            throws IllegalArgumentException {
        
        super(
                pTitle,
                pType );
        if( pKey == null ) {
            System.out.println( "Illegal Key argument: is null." );
            throw new IllegalArgumentException( "Illegal Key argument: is null." );
        }
        mKey = new Integer( pKey );
    }
    
    public DatabaseBookmark(
            DatabaseBookmark pPrototype )
            throws IllegalArgumentException {
        
        super(
                pPrototype );
        mKey = pPrototype.getKey();
    }
    
    public boolean setKey(
            Integer pKey ) {
        
        if( pKey == null ) {
            return false;
        }
        mKey = new Integer( pKey );
        return true;
    }
    
    public Integer getKey() {
        
        return new Integer( mKey );
    }
    
    public DatabaseBookmark clone() {
        
        DatabaseBookmark lClone = null;
        try {
            lClone = new DatabaseBookmark( this );
        } catch ( IllegalArgumentException eFake ) {
        }
        return lClone;
    }
    
    private Integer mKey;
}