package visualization;

import publications.*;

import java.util.Vector;

import javax.swing.DefaultListModel;

import travellers.Traveller;

import readers.Reader;
import readers.DatabaseReader;

import connector.MySQLRDBMSConnector;
import connector.RDBMSMounter;
import connector.RDBMSConnector;
import connector.DatabaseConnectionDialog;

public class LightClient extends javax.swing.JFrame {
    
    public LightClient() {
        initComponents();
        mTraveller = null;
    }
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        msPublicationPanel = new javax.swing.JPanel();
        msPublicationTitleField = new javax.swing.JTextField();
        msPublicationTitleLabel = new javax.swing.JLabel();
        msPublicationAuthorLabel = new javax.swing.JLabel();
        msPublicationAuthorField = new javax.swing.JTextField();
        msPublicationTypeLabel = new javax.swing.JLabel();
        msPublicationTypeField = new javax.swing.JTextField();
        msBookmarksPanel = new javax.swing.JPanel();
        msPublicationBookmarksListLabel = new javax.swing.JLabel();
        msPublicationBookmarksScrollPane = new javax.swing.JScrollPane();
        msPublicationBookmarksList = new javax.swing.JList();
        msPublicationBookmarksPreviousButton = new javax.swing.JButton();
        msPublicationBookmarksOpenButton = new javax.swing.JButton();
        msPublicationBookmarksNextButton = new javax.swing.JButton();
        msPublicationViewButton = new javax.swing.JButton();
        msSearchPanel = new javax.swing.JPanel();
        msTopicsLabel = new javax.swing.JLabel();
        msTopicsComboBox = new javax.swing.JComboBox();
        msTopicsOpenButton = new javax.swing.JButton();
        msSearchLabel = new javax.swing.JLabel();
        msSearchField = new javax.swing.JTextField();
        msSearchByAuthorsCheckBox = new javax.swing.JCheckBox();
        msSearchByPublicationTitleCheckBox = new javax.swing.JCheckBox();
        msSearchButton = new javax.swing.JButton();
        msCardIndexLabel = new javax.swing.JLabel();
        msCardIndexComboBox = new javax.swing.JComboBox();
        msCardIndexOpenButton = new javax.swing.JButton();
        msMenuBar = new javax.swing.JMenuBar();
        msLibraryMenu = new javax.swing.JMenu();
        msConnectToLibraryRDBMSMenuItem = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("\u0427\u0438\u0442\u0430\u0442\u0435\u043b\u044c \u0431\u0438\u0431\u043b\u0438\u043e\u0442\u0435\u043a\u0438");
        msPublicationPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED), "\u0418\u0437\u0434\u0430\u043d\u0438\u0435", javax.swing.border.TitledBorder.LEFT, javax.swing.border.TitledBorder.TOP));
        msPublicationTitleField.setEditable(false);
        msPublicationTitleField.setFont(new java.awt.Font("Tahoma", 1, 11));
        msPublicationTitleField.setHorizontalAlignment(javax.swing.JTextField.LEFT);

        msPublicationTitleLabel.setText("\u041d\u0430\u0437\u0432\u0430\u043d\u0438\u0435");

        msPublicationAuthorLabel.setText("\u0410\u0432\u0442\u043e\u0440");

        msPublicationAuthorField.setEditable(false);
        msPublicationAuthorField.setFont(new java.awt.Font("Tahoma", 1, 11));
        msPublicationAuthorField.setHorizontalAlignment(javax.swing.JTextField.LEFT);

        msPublicationTypeLabel.setText("\u0422\u0438\u043f");

        msPublicationTypeField.setEditable(false);
        msPublicationTypeField.setFont(new java.awt.Font("Tahoma", 1, 11));
        msPublicationTypeField.setHorizontalAlignment(javax.swing.JTextField.LEFT);

        msBookmarksPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED), "\u0421\u0441\u044b\u043b\u043a\u0438"));
        msPublicationBookmarksListLabel.setText("\u0421\u043f\u0438\u0441\u043e\u043a \u0441\u0441\u044b\u043b\u043e\u043a");

        msPublicationBookmarksList.setFont(new java.awt.Font("Tahoma", 3, 11));
        msPublicationBookmarksList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        msPublicationBookmarksScrollPane.setViewportView(msPublicationBookmarksList);

        msPublicationBookmarksPreviousButton.setText("\u041f\u0440\u0435\u0434\u044b\u0434\u0443\u0449\u0430\u044f \u0441\u0441\u044b\u043b\u043a\u0430");
        msPublicationBookmarksPreviousButton.setEnabled(false);
        msPublicationBookmarksPreviousButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                msPublicationBookmarksPreviousButtonActionPerformed(evt);
            }
        });

        msPublicationBookmarksOpenButton.setText("\u041e\u0442\u043a\u0440\u044b\u0442\u044c \u0441\u0441\u044b\u043b\u043a\u0443");
        msPublicationBookmarksOpenButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                msPublicationBookmarksOpenButtonActionPerformed(evt);
            }
        });

        msPublicationBookmarksNextButton.setText("\u0421\u043b\u0435\u0434\u0443\u044e\u0449\u0430\u044f \u0441\u0441\u044b\u043b\u043a\u0430");
        msPublicationBookmarksNextButton.setEnabled(false);
        msPublicationBookmarksNextButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                msPublicationBookmarksNextButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout msBookmarksPanelLayout = new org.jdesktop.layout.GroupLayout(msBookmarksPanel);
        msBookmarksPanel.setLayout(msBookmarksPanelLayout);
        msBookmarksPanelLayout.setHorizontalGroup(
            msBookmarksPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(msBookmarksPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(msBookmarksPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(msPublicationBookmarksScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 420, Short.MAX_VALUE)
                    .add(msBookmarksPanelLayout.createSequentialGroup()
                        .add(msPublicationBookmarksListLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 410, Short.MAX_VALUE)
                        .addContainerGap())
                    .add(msBookmarksPanelLayout.createSequentialGroup()
                        .add(msPublicationBookmarksPreviousButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 142, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(msPublicationBookmarksOpenButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 123, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(msPublicationBookmarksNextButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addContainerGap())))
        );
        msBookmarksPanelLayout.setVerticalGroup(
            msBookmarksPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(msBookmarksPanelLayout.createSequentialGroup()
                .add(msPublicationBookmarksListLabel)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msPublicationBookmarksScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 109, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msBookmarksPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(msPublicationBookmarksPreviousButton)
                    .add(msPublicationBookmarksOpenButton)
                    .add(msPublicationBookmarksNextButton))
                .addContainerGap())
        );

        msPublicationViewButton.setText("\u041e\u0442\u043a\u0440\u044b\u0442\u044c");
        msPublicationViewButton.setEnabled(false);
        msPublicationViewButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                msPublicationViewButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout msPublicationPanelLayout = new org.jdesktop.layout.GroupLayout(msPublicationPanel);
        msPublicationPanel.setLayout(msPublicationPanelLayout);
        msPublicationPanelLayout.setHorizontalGroup(
            msPublicationPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, msPublicationPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(msPublicationPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, msBookmarksPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(msPublicationPanelLayout.createSequentialGroup()
                        .add(msPublicationPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(msPublicationTypeLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(msPublicationAuthorLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(msPublicationTitleLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 61, Short.MAX_VALUE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(msPublicationPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(msPublicationTypeField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 377, Short.MAX_VALUE)
                            .add(msPublicationAuthorField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 377, Short.MAX_VALUE)
                            .add(msPublicationTitleField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 377, Short.MAX_VALUE)))
                    .add(msPublicationViewButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 150, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        msPublicationPanelLayout.setVerticalGroup(
            msPublicationPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(msPublicationPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(msPublicationPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(msPublicationTitleLabel)
                    .add(msPublicationTitleField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msPublicationPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(msPublicationAuthorField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(msPublicationAuthorLabel))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msPublicationPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(msPublicationTypeField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(msPublicationTypeLabel))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msPublicationViewButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msBookmarksPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        msSearchPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED), "\u041f\u043e\u0438\u0441\u043a", javax.swing.border.TitledBorder.LEFT, javax.swing.border.TitledBorder.TOP));
        msTopicsLabel.setText("\u0422\u0435\u043c\u0430\u0442\u0438\u0447\u0435\u0441\u043a\u0438\u0435 \u0441\u0431\u043e\u0440\u043d\u0438\u043a\u0438");

        msTopicsOpenButton.setText("\u041e\u0442\u043a\u0440\u044b\u0442\u044c \u0441\u0431\u043e\u0440\u043d\u0438\u043a");
        msTopicsOpenButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                msTopicsOpenButtonActionPerformed(evt);
            }
        });

        msSearchLabel.setText("\u041f\u043e\u0438\u0441\u043a \u0438\u0437\u0434\u0430\u043d\u0438\u0439");

        msSearchByAuthorsCheckBox.setText("\u0438\u0441\u043a\u0430\u0442\u044c \u043f\u043e \u0430\u0432\u0442\u043e\u0440\u0430\u043c");
        msSearchByAuthorsCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        msSearchByAuthorsCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));

        msSearchByPublicationTitleCheckBox.setText("\u0438\u0441\u043a\u0430\u0442\u044c \u043f\u043e \u0438\u0437\u0434\u0430\u043d\u0438\u044f\u043c");
        msSearchByPublicationTitleCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        msSearchByPublicationTitleCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));

        msSearchButton.setText("\u041f\u043e\u0438\u0441\u043a");
        msSearchButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                msSearchButtonActionPerformed(evt);
            }
        });

        msCardIndexLabel.setText("\u041a\u0430\u0440\u0442\u043e\u0442\u0435\u043a\u0438");

        msCardIndexOpenButton.setText("\u041e\u0442\u043a\u0440\u044b\u0442\u044c \u043a\u0430\u0440\u0442\u043e\u0442\u0435\u043a\u0443");
        msCardIndexOpenButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                msCardIndexOpenButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout msSearchPanelLayout = new org.jdesktop.layout.GroupLayout(msSearchPanel);
        msSearchPanel.setLayout(msSearchPanelLayout);
        msSearchPanelLayout.setHorizontalGroup(
            msSearchPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(msSearchPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(msSearchPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(msCardIndexLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 345, Short.MAX_VALUE)
                    .add(msCardIndexComboBox, 0, 345, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, msCardIndexOpenButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 150, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, msTopicsLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 345, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, msTopicsComboBox, 0, 345, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, msTopicsOpenButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 150, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(msSearchLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 345, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, msSearchField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 345, Short.MAX_VALUE)
                    .add(msSearchByAuthorsCheckBox, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 345, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, msSearchByPublicationTitleCheckBox, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 345, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, msSearchButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 150, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        msSearchPanelLayout.setVerticalGroup(
            msSearchPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(msSearchPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(msCardIndexLabel)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msCardIndexComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msCardIndexOpenButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msTopicsLabel)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msTopicsComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msTopicsOpenButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msSearchLabel)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msSearchField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msSearchByAuthorsCheckBox)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msSearchByPublicationTitleCheckBox)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msSearchButton)
                .addContainerGap(46, Short.MAX_VALUE))
        );

        msLibraryMenu.setText("\u0411\u0438\u0431\u043b\u0438\u043e\u0442\u0435\u043a\u0430");
        msConnectToLibraryRDBMSMenuItem.setText("\u0421\u043e\u0435\u0434\u0438\u043d\u0438\u0442\u044c\u0441\u044f \u0441 \u0431\u0430\u0437\u043e\u0439 \u0434\u0430\u043d\u043d\u044b\u0445 \u0431\u0438\u0431\u043b\u0438\u043e\u0442\u0435\u043a\u0438");
        msConnectToLibraryRDBMSMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                msConnectToLibraryRDBMSMenuItemActionPerformed(evt);
            }
        });

        msLibraryMenu.add(msConnectToLibraryRDBMSMenuItem);

        msMenuBar.add(msLibraryMenu);

        setJMenuBar(msMenuBar);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(msSearchPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(msPublicationPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, msPublicationPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, msSearchPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void msSearchButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_msSearchButtonActionPerformed
        
        if( ! isTravellerReady() ) {
            return;
        }
        String lConditions = msSearchField.getText();
        boolean lByAuthors = msSearchByAuthorsCheckBox.isSelected();
        boolean lByPublications = msSearchByPublicationTitleCheckBox.isSelected();
        Publication lSearchPublication = mTraveller.search(
                lConditions,
                lByAuthors,
                lByPublications );
        if( lSearchPublication != null ) {
            showPublication( lSearchPublication );
        }
    }//GEN-LAST:event_msSearchButtonActionPerformed

    private void msCardIndexOpenButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_msCardIndexOpenButtonActionPerformed
        if( ! isTravellerReady() ) {
            return;
        }
        String lSelectedItem = ( String )msCardIndexComboBox.getSelectedItem();
        if( lSelectedItem.equals( " " ) ) {
            Publication lAuthorList = mTraveller.getAuthorsList();
            if( lAuthorList != null ) {
                showPublication( lAuthorList );
            }
        } else if( lSelectedItem.equals( " " ) ) {
            Publication lBookList = mTraveller.getBookList();
            if( lBookList != null ) {
                showPublication( lBookList );
            }
        }
    }//GEN-LAST:event_msCardIndexOpenButtonActionPerformed

    private void msPublicationBookmarksNextButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_msPublicationBookmarksNextButtonActionPerformed

        if( ! isTravellerReady() ) {
            return;
        }
        if( mTraveller.couldTravelToNext() ) {
            Publication lNextPublication = mTraveller.travelToNext();
            if( lNextPublication != null ) {
                showPublication( lNextPublication );
            }
        }
    }//GEN-LAST:event_msPublicationBookmarksNextButtonActionPerformed

    private void msPublicationBookmarksPreviousButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_msPublicationBookmarksPreviousButtonActionPerformed

        if( ! isTravellerReady() ) {
            return;
        }
        if( mTraveller.couldTravelToPrevious() ) {
            Publication lPreviousPublication = mTraveller.travelToPrevious();
            if( lPreviousPublication != null ) {
                showPublication( lPreviousPublication );
            }
        }
    }//GEN-LAST:event_msPublicationBookmarksPreviousButtonActionPerformed

    private void msPublicationViewButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_msPublicationViewButtonActionPerformed
        
        if( ! isTravellerReady() ) {
            return;
        }
        Publication lActivePublication = mTraveller.getCurrent();
        if( lActivePublication.isViewable() ) {
            lActivePublication.viewExternally();
        }
    }//GEN-LAST:event_msPublicationViewButtonActionPerformed

    private void msPublicationBookmarksOpenButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_msPublicationBookmarksOpenButtonActionPerformed
        
        if( ! isTravellerReady() ) {
            return;
        }
        Integer lBookmarkIndex = msPublicationBookmarksList.getSelectedIndex();
        Publication lActivePublication = mTraveller.getCurrent();
        if( ( lBookmarkIndex >= 0 ) && ( lBookmarkIndex < lActivePublication.bookmarks() ) ) {
            Bookmark lBookmark = lActivePublication.getBookmark( lBookmarkIndex );
            Publication lPublication = mTraveller.travelToBookmark( lBookmark );
            if( lPublication != null ) {
                showPublication( lPublication );
            }
        }
    }//GEN-LAST:event_msPublicationBookmarksOpenButtonActionPerformed

    private void msTopicsOpenButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_msTopicsOpenButtonActionPerformed
        
        if( ! isTravellerReady() ) {
            return;
        }
        String lTopic = ( String )msTopicsComboBox.getSelectedItem();
        if( lTopic == null ) {
            return;
        }
        Publication lTopicPublication = mTraveller.travelToTopic( lTopic );
        if( lTopicPublication != null ) {
            showPublication( lTopicPublication );
        }
    }//GEN-LAST:event_msTopicsOpenButtonActionPerformed

    private void msConnectToLibraryRDBMSMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_msConnectToLibraryRDBMSMenuItemActionPerformed
        
        RDBMSMounter lMounter = RDBMSMounter.getInstance();
        lMounter.add(
                "MySQL",
                "com.mysql.jdbc.Driver",
                new MySQLRDBMSConnector() );
        DatabaseConnectionDialog lDialog = new DatabaseConnectionDialog(
                this,
                true );
        lDialog.setVisible( true );
        RDBMSConnector lConnector = null;
        if( lDialog.getReturnStatus() == lDialog.RET_OK ) {
            lConnector = lDialog.getConnector();
        } else {
            lConnector = null;
        }
        if( lConnector == null ) {
            msTopicsComboBox.removeAllItems();
            msCardIndexComboBox.removeAllItems();
            return;
        }
        Reader lReader = new DatabaseReader( lConnector.mountConnection() );
        if( lReader.ready() ) {
            mTraveller = new Traveller( lReader );
            Vector< String > lTopics = mTraveller.getTopics();
            for( int iTopic = 0; iTopic < lTopics.size(); iTopic++ ) {
                msTopicsComboBox.addItem( lTopics.get( iTopic ) );
            }
        }
        msCardIndexComboBox.addItem( new String( " " ) );
        msCardIndexComboBox.addItem( new String( " " ) );
    }//GEN-LAST:event_msConnectToLibraryRDBMSMenuItemActionPerformed
    
    public static void main(
            String args[] ) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new LightClient().setVisible(true);
            }
        } );
    }
    
    private void showPublication(
            Publication pPublication ) {

        if( pPublication != null ) {
            msPublicationTitleField.setText( pPublication.getTitle() );
            Vector< Author > lAuthors = pPublication.getAuthors();
            String lTopicAuthors = new String();
            for( int iAuthor = 0; iAuthor < lAuthors.size(); iAuthor++ ) {
                Author lAuthor = lAuthors.get( iAuthor );
                if( iAuthor > 0 ) {
                    lTopicAuthors = lTopicAuthors + ", ";
                }
                lTopicAuthors = lTopicAuthors + lAuthor.getName() + " " + lAuthor.getSurname();
            }
            msPublicationAuthorField.setText( lTopicAuthors );
            msPublicationTypeField.setText( pPublication.getType().toString() );
        }
        msPublicationViewButton.setEnabled( pPublication.isViewable() );
        DefaultListModel lBookmarks = new DefaultListModel();
        for( int iBookmark = 0; iBookmark < pPublication.bookmarks(); iBookmark++ ) {
            Bookmark lBookmark = pPublication.getBookmark( iBookmark );
            lBookmarks.addElement( lBookmark.getTitle() );
        }
        msPublicationBookmarksList.setModel(
                lBookmarks );
        msPublicationBookmarksList.validate();
        if( mTraveller.couldTravelToPrevious() ) {
            msPublicationBookmarksPreviousButton.setEnabled( true );
        } else {
            msPublicationBookmarksPreviousButton.setEnabled( false );
        }
        if( mTraveller.couldTravelToNext() ) {
            msPublicationBookmarksNextButton.setEnabled( true );
        } else {
            msPublicationBookmarksNextButton.setEnabled( false );
        }
    }
    
    private boolean isTravellerReady() {
        
        if( mTraveller != null ) {
            return true;
        } else {
            return false;
        }
    }
    
    private Traveller mTraveller;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel msBookmarksPanel;
    private javax.swing.JComboBox msCardIndexComboBox;
    private javax.swing.JLabel msCardIndexLabel;
    private javax.swing.JButton msCardIndexOpenButton;
    private javax.swing.JMenuItem msConnectToLibraryRDBMSMenuItem;
    private javax.swing.JMenu msLibraryMenu;
    private javax.swing.JMenuBar msMenuBar;
    private javax.swing.JTextField msPublicationAuthorField;
    private javax.swing.JLabel msPublicationAuthorLabel;
    private javax.swing.JList msPublicationBookmarksList;
    private javax.swing.JLabel msPublicationBookmarksListLabel;
    private javax.swing.JButton msPublicationBookmarksNextButton;
    private javax.swing.JButton msPublicationBookmarksOpenButton;
    private javax.swing.JButton msPublicationBookmarksPreviousButton;
    private javax.swing.JScrollPane msPublicationBookmarksScrollPane;
    private javax.swing.JPanel msPublicationPanel;
    private javax.swing.JTextField msPublicationTitleField;
    private javax.swing.JLabel msPublicationTitleLabel;
    private javax.swing.JTextField msPublicationTypeField;
    private javax.swing.JLabel msPublicationTypeLabel;
    private javax.swing.JButton msPublicationViewButton;
    private javax.swing.JButton msSearchButton;
    private javax.swing.JCheckBox msSearchByAuthorsCheckBox;
    private javax.swing.JCheckBox msSearchByPublicationTitleCheckBox;
    private javax.swing.JTextField msSearchField;
    private javax.swing.JLabel msSearchLabel;
    private javax.swing.JPanel msSearchPanel;
    private javax.swing.JComboBox msTopicsComboBox;
    private javax.swing.JLabel msTopicsLabel;
    private javax.swing.JButton msTopicsOpenButton;
    // End of variables declaration//GEN-END:variables
    
}
